using System;
using System.Linq;
using System.Linq.Expressions;
using Microsoft.EntityFrameworkCore;

namespace Luticate2.Auth.Utils.Business.Converters.ObjectConverterDescriptor
{
    public class LuObjectConverterDescriptorQueryable : LuObjectConverterDescriptor
    {
        public LuObjectConverterDescriptorQueryable()
        {
            AddDynamicMethodConverterTemplate(
                (Expression<Func<DbSet<object>, Expression<Func<object, bool>>, bool>>)((source, filter) => source.Any(filter)));
            AddDynamicMethodConverterTemplate(
                (Expression<Func<DbSet<object>, Expression<Func<object, bool>>, IQueryable<object>>>)((source, filter) => source.Where(filter)));
        }
    }
}