using System.Linq.Expressions;
using System.Reflection;
using Luticate2.Auth.Utils.Dbo.Result;

namespace Luticate2.Auth.Utils.Interfaces
{
    public interface ILuObjectConverterDescriptorOptions
    {
        ILuConvertersTypeConverter TypeConverter { get; }
    }

    public interface ILuObjectConverterDescriptor
    {
        LuResult<LambdaExpression> GetMemberValueExpression(MemberInfo memberInfo, ILuObjectConverterDescriptorOptions options);

        LuResult<LambdaExpression> GetMethodValueExpression(MethodInfo methodInfo, ILuObjectConverterDescriptorOptions options);
    }

    public interface ILuObjectConverterDescriptor<TTypeFrom, TTypeTo> : ILuObjectConverterDescriptor
    {
    }

    public interface ILuObjectConverterDescriptorIdentity : ILuObjectConverterDescriptor
    {
    }
}